package ipsk.db.speech.project;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import ipsk.beans.PreferredDisplayOrder;
import ipsk.beans.validation.Input;
import ipsk.db.speech.Project;
import ipsk.util.ResourceBundleName;
import ipsk.util.ResourceKey;
import ipsk.util.annotations.TextAreaView;

@Entity
@Table(name = "project_localized_default_research_purpose", schema = "public")
@ResourceBundleName("ipsk.db.speech.PropertyNames")
//@ResourceKey("localized_message")
//@PluralResourceKey("localized_messages")
@PreferredDisplayOrder("id,project,languageISO3code,localizedText")
@XmlType(name="localized_default_purpose_text")
public class LocalizedDefaultPurposeText {

	private int id;
	private String languageISO3code;
	private String localizedText;
	
	private Project project;
	
	
	public LocalizedDefaultPurposeText(){
		super();
	}
	@Id
	@Column(name = "id", unique = true, nullable = false)
    @GeneratedValue(generator="id_gen")
    @ResourceKey("id")
    public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}
	
	@ManyToOne
	@ResourceKey("project")
	@XmlTransient
	public Project getProject() {
		return project;
	}
	public void setProject(Project project) {
		this.project = project;
	}
	
	@Column(length = 3, updatable = false)
	@ResourceKey("language")
	@Input(required=true)
	public String getLanguageISO3code() {
		return languageISO3code;
	}

	public void setLanguageISO3code(String languageISO3code) {
		this.languageISO3code = languageISO3code;
	}
	@Column(length = 10000)
	@TextAreaView
	@ResourceKey("text")
	public String getLocalizedText() {
		return localizedText;
	}

	public void setLocalizedText(String localizedText) {
		this.localizedText = localizedText;
	}
	
}
